<template>
  <div :class="$style.searchView">
    <search-block @on-search="setCurrentSearchQuery($event)"></search-block>
    <template v-if="currentQuery && totalBooksCount !== 0">
      <div :class="$style.booksList">
        <book-list :books="books" />
      </div>
      <div :class="$style.pagination">
        <pagination
          :currentPage="currentPage"
          :itemsCount="totalBooksCount"
          @on-page-change="changePage($event)"
        />
      </div>
    </template>
  </div>
</template>

<script>
import { SearchBlock, BookList } from "@/components";
import { Pagination } from "@/components/ui";

export default {
  name: "SearchDesktopView",
  components: { SearchBlock, BookList, Pagination },
  data() {
    return {
      currentPage: 1,
      currentQuery: ""
    };
  },
  computed: {
    books() {
      return this.$store.getters.bookList;
    },
    totalBooksCount() {
      return this.$store.getters.totalCount;
    }
  },
  methods: {
    setCurrentSearchQuery(query) {
      this.currentQuery = query;
      this.currentPage = 1;
      this.getBookList();
    },
    changePage(page) {
      this.currentPage = page;
      this.getBookList();
    },
    getBookList() {
      const params = {
        q: this.currentQuery,
        startIndex: this.currentPage - 1
      };
      this.$store.dispatch("getBookList", params);
    }
  }
};
</script>

<style lang="scss" module>
.searchView {
  padding: 64px;
  display: flex;
  flex-direction: column;

  .booksList {
    flex: 1;
    margin-top: 45px;
  }
}

.pagination {
  display: flex;
  justify-content: center;
  margin-top: 50px;
}
</style>
